#include "beremiz.h"
#ifndef __POUS_H
#define __POUS_H

#include "accessor.h"
#include "iec_std_lib.h"

__DECLARE_ENUMERATED_TYPE(LOGLEVEL,
  LOGLEVEL__CRITICAL,
  LOGLEVEL__WARNING,
  LOGLEVEL__INFO,
  LOGLEVEL__DEBUG
)
__DECLARE_STRUCT_TYPE(EEREGLWORD,
  DINT ADDR;
    BYTE TY;
  )
__DECLARE_STRUCT_TYPE(EEREGBYTE,
  DINT ADDR;
    BYTE TY;
  )
__DECLARE_STRUCT_TYPE(EEREGLREAL,
  DINT ADDR;
    BYTE TY;
  )
__DECLARE_STRUCT_TYPE(EEREGREAL,
  DINT ADDR;
    BYTE TY;
  )
__DECLARE_STRUCT_TYPE(EEREGDWORD,
  DINT ADDR;
    BYTE TY;
  )
__DECLARE_STRUCT_TYPE(EEREGWORD,
  DINT ADDR;
    BYTE TY;
  )
// FUNCTION_BLOCK LOGGER
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,TRIG)
  __DECLARE_VAR(STRING,MSG)
  __DECLARE_VAR(LOGLEVEL,LEVEL)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(BOOL,TRIG0)

} LOGGER;

void LOGGER_init__(LOGGER *data__, BOOL retain);
// Code part
void LOGGER_body__(LOGGER *data__);
// FUNCTION
REAL SCALEA(
  BOOL EN, 
  BOOL *__ENO, 
  BOOL EX, 
  REAL V, 
  REAL KA, 
  REAL KB, 
  REAL Y);
// FUNCTION
REAL SCALEA_KB(
  BOOL EN, 
  BOOL *__ENO, 
  BOOL EX, 
  REAL V1, 
  REAL V2, 
  REAL Y1, 
  REAL Y2, 
  REAL KB);
// FUNCTION_BLOCK TONTEST
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,IN)
  __DECLARE_VAR(DWORD,MS)
  __DECLARE_VAR(BOOL,Q)
  __DECLARE_VAR(TIME,ET)
  __DECLARE_VAR(DWORD,EDW)
  __DECLARE_VAR(REAL,EREA)

  // FB private variables - TEMP, private and located variables
  TON TON1;
  __DECLARE_VAR(BOOL,TON1_IN)
  __DECLARE_VAR(TIME,TON1_TM)

} TONTEST;

void TONTEST_init__(TONTEST *data__, BOOL retain);
// Code part
void TONTEST_body__(TONTEST *data__);
// FUNCTION
REAL SCALEA_KA(
  BOOL EN, 
  BOOL *__ENO, 
  BOOL EX, 
  REAL V1, 
  REAL V2, 
  REAL Y1, 
  REAL Y2, 
  REAL KA);
// FUNCTION_BLOCK TONCONT
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,IN)
  __DECLARE_VAR(BOOL,Q)
  __DECLARE_VAR(TIME,ET)

  // FB private variables - TEMP, private and located variables
  TON TON1;
  __DECLARE_VAR(BOOL,TON1_IN)
  __DECLARE_VAR(TIME,TON1_TM)
  TON TON1INC;
  __DECLARE_VAR(BOOL,TON1INC_IN)
  __DECLARE_VAR(TIME,TON1INC_TM)

} TONCONT;

void TONCONT_init__(TONCONT *data__, BOOL retain);
// Code part
void TONCONT_body__(TONCONT *data__);
// FUNCTION_BLOCK FLRTUN
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(REAL,V)
  __DECLARE_VAR(REAL,DIFF)
  __DECLARE_VAR(BYTE,PRO)
  __DECLARE_VAR(BYTE,OK)
  __DECLARE_VAR(REAL,OY)
  __DECLARE_VAR(DWORD,OTM)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(BOOL,TUNDONE)
  __DECLARE_VAR(REAL,TM1)
  __DECLARE_VAR(BOOL,V1SET)
  __DECLARE_VAR(REAL,V01)
  TONCONT TONCONT1;
  __DECLARE_VAR(BOOL,TONCONT1_IN)

} FLRTUN;

void FLRTUN_init__(FLRTUN *data__, BOOL retain);
// Code part
void FLRTUN_body__(FLRTUN *data__);
// FUNCTION
BOOL GETBITWO(
  BOOL EN, 
  BOOL *__ENO, 
  WORD WO, 
  BYTE POS);
// FUNCTION_BLOCK FILTRD
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(BOOL,V)
  __DECLARE_VAR(TIME,TM)
  __DECLARE_VAR(BOOL,OV)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(BOOL,VAL)
  TON TON0;
  TON TON1;

} FILTRD;

void FILTRD_init__(FILTRD *data__, BOOL retain);
// Code part
void FILTRD_body__(FILTRD *data__);
// FUNCTION_BLOCK FLR1
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(REAL,V)
  __DECLARE_VAR(REAL,SP)
  __DECLARE_VAR(BYTE,PRO)
  __DECLARE_VAR(BOOL,SCK)
  __DECLARE_VAR(DWORD,TM)
  __DECLARE_VAR(REAL,DV)
  __DECLARE_VAR(REAL,DZ)
  __DECLARE_VAR(REAL,DE)
  __DECLARE_VAR(DWORD,DETM)
  __DECLARE_VAR(BYTE,YM)
  __DECLARE_VAR(BYTE,OK)
  __DECLARE_VAR(REAL,OY)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(REAL,VPREV)
  __DECLARE_VAR(REAL,TMDV)
  __DECLARE_VAR(SINT,UPDOWN)
  __DECLARE_VAR(BOOL,SCKSET)
  __DECLARE_VAR(BOOL,ERRORSET)
  __DECLARE_VAR(REAL,ER)
  TON TON_DE;
  __DECLARE_VAR(BOOL,TON_DE_IN)
  __DECLARE_VAR(TIME,TON_DE_TM)
  __DECLARE_VAR(REAL,DEV)
  __DECLARE_VAR(BOOL,DEV1SET)
  __DECLARE_VAR(BOOL,DEV2SET)
  TON TON_DV;
  __DECLARE_VAR(BOOL,TON_DV_IN)
  __DECLARE_VAR(TIME,TON_DV_TM)

} FLR1;

void FLR1_init__(FLR1 *data__, BOOL retain);
// Code part
void FLR1_body__(FLR1 *data__);
// FUNCTION_BLOCK FLR2
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(REAL,V)
  __DECLARE_VAR(REAL,SP)
  __DECLARE_VAR(BYTE,PRO)
  __DECLARE_VAR(DWORD,TM)
  __DECLARE_VAR(REAL,DV)
  __DECLARE_VAR(REAL,DZ)
  __DECLARE_VAR(REAL,DE)
  __DECLARE_VAR(DWORD,DETM)
  __DECLARE_VAR(BYTE,YM)
  __DECLARE_VAR(BYTE,OK)
  __DECLARE_VAR(REAL,OY)

  // FB private variables - TEMP, private and located variables
  TON TON_WORK;
  __DECLARE_VAR(BOOL,TON_WORK_IN)
  __DECLARE_VAR(TIME,TON_WORK_TM)
  FLR1 FLR1_1;

} FLR2;

void FLR2_init__(FLR2 *data__, BOOL retain);
// Code part
void FLR2_body__(FLR2 *data__);
// FUNCTION_BLOCK PIDTUN
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(REAL,V)
  __DECLARE_VAR(REAL,DIFF)
  __DECLARE_VAR(BYTE,TY)
  __DECLARE_VAR(BYTE,PRO)
  __DECLARE_VAR(BYTE,OK)
  __DECLARE_VAR(REAL,OY)
  __DECLARE_VAR(REAL,OKP)
  __DECLARE_VAR(REAL,OKI)
  __DECLARE_VAR(REAL,OKD)
  __DECLARE_VAR(DWORD,OTM)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(BOOL,TUNDONE)
  __DECLARE_VAR(REAL,TM1)
  __DECLARE_VAR(REAL,TM2)
  __DECLARE_VAR(REAL,TMSUM)
  __DECLARE_VAR(BOOL,V1SET)
  __DECLARE_VAR(REAL,V01)
  __DECLARE_VAR(REAL,V063)
  __DECLARE_VAR(REAL,RR)
  __DECLARE_VAR(REAL,TM1SEC)
  TONCONT TONCONT1;
  __DECLARE_VAR(BOOL,TONCONT1_IN)

} PIDTUN;

void PIDTUN_init__(PIDTUN *data__, BOOL retain);
// Code part
void PIDTUN_body__(PIDTUN *data__);
// FUNCTION
WORD SETBITWO(
  BOOL EN, 
  BOOL *__ENO, 
  WORD WO, 
  BYTE POS, 
  BOOL VAL);
// FUNCTION_BLOCK FILTRA
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(REAL,V)
  __DECLARE_VAR(REAL,K)
  __DECLARE_VAR(REAL,OV)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(REAL,VAL)
  __DECLARE_VAR(REAL,KLIM)

} FILTRA;

void FILTRA_init__(FILTRA *data__, BOOL retain);
// Code part
void FILTRA_body__(FILTRA *data__);
// FUNCTION_BLOCK PID1
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(REAL,V)
  __DECLARE_VAR(REAL,SP)
  __DECLARE_VAR(BYTE,TY)
  __DECLARE_VAR(BYTE,PRO)
  __DECLARE_VAR(REAL,KP)
  __DECLARE_VAR(REAL,KI)
  __DECLARE_VAR(REAL,KD)
  __DECLARE_VAR(BOOL,SCK)
  __DECLARE_VAR(REAL,DI)
  __DECLARE_VAR(REAL,DZ)
  __DECLARE_VAR(REAL,DE)
  __DECLARE_VAR(DWORD,DETM)
  __DECLARE_VAR(BYTE,YM)
  __DECLARE_VAR(BYTE,OK)
  __DECLARE_VAR(REAL,OY)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(REAL,ER)
  __DECLARE_VAR(REAL,ERABS)
  __DECLARE_VAR(REAL,ERPREV)
  __DECLARE_VAR(REAL,ERDIFF)
  __DECLARE_VAR(REAL,PPART)
  __DECLARE_VAR(REAL,IPART)
  __DECLARE_VAR(REAL,DPART)
  __DECLARE_VAR(REAL,DEV)
  __DECLARE_VAR(BOOL,DEV1SET)
  __DECLARE_VAR(BOOL,DEV2SET)
  __DECLARE_VAR(BOOL,SCKSET)
  __DECLARE_VAR(BOOL,ERRORSET)
  TON TON_DE;
  __DECLARE_VAR(BOOL,TON_DE_IN)
  __DECLARE_VAR(TIME,TON_DE_TM)

} PID1;

void PID1_init__(PID1 *data__, BOOL retain);
// Code part
void PID1_body__(PID1 *data__);
// FUNCTION_BLOCK PID2
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(REAL,V)
  __DECLARE_VAR(REAL,SP)
  __DECLARE_VAR(BYTE,TY)
  __DECLARE_VAR(BYTE,PRO)
  __DECLARE_VAR(REAL,KP)
  __DECLARE_VAR(REAL,KI)
  __DECLARE_VAR(REAL,KD)
  __DECLARE_VAR(DWORD,TM)
  __DECLARE_VAR(REAL,DI)
  __DECLARE_VAR(REAL,DZ)
  __DECLARE_VAR(REAL,DE)
  __DECLARE_VAR(DWORD,DETM)
  __DECLARE_VAR(BYTE,YM)
  __DECLARE_VAR(BYTE,OK)
  __DECLARE_VAR(REAL,OY)

  // FB private variables - TEMP, private and located variables
  TON TON_WORK;
  __DECLARE_VAR(BOOL,TON_WORK_IN)
  __DECLARE_VAR(TIME,TON_WORK_TM)
  PID1 PID1_1;

} PID2;

void PID2_init__(PID2 *data__, BOOL retain);
// Code part
void PID2_body__(PID2 *data__);
// FUNCTION
INT DEC(
  BOOL EN, 
  BOOL *__ENO, 
  BOOL EX, 
  INT V);
// FUNCTION
INT INC(
  BOOL EN, 
  BOOL *__ENO, 
  BOOL EX, 
  INT V);
// FUNCTION
BOOL SOFTRESET(
  BOOL EN, 
  BOOL *__ENO, 
  BOOL EX);
// FUNCTION_BLOCK EEREADLREAL
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(EEREGLREAL,REG)
  __DECLARE_VAR(LREAL,OVAL)
  __DECLARE_VAR(BYTE,OK)

  // FB private variables - TEMP, private and located variables

} EEREADLREAL;

void EEREADLREAL_init__(EEREADLREAL *data__, BOOL retain);
// Code part
void EEREADLREAL_body__(EEREADLREAL *data__);
// FUNCTION_BLOCK EEREADLWORD
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(EEREGLWORD,REG)
  __DECLARE_VAR(LWORD,OVAL)
  __DECLARE_VAR(BYTE,OK)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(EEREGLREAL,REGLREAL)
  EEREADLREAL FUNC;

} EEREADLWORD;

void EEREADLWORD_init__(EEREADLWORD *data__, BOOL retain);
// Code part
void EEREADLWORD_body__(EEREADLWORD *data__);
// FUNCTION
BOOL EECLR(
  BOOL EN, 
  BOOL *__ENO, 
  BOOL EX);
// FUNCTION_BLOCK EEWRITELREAL
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(EEREGLREAL,REG)
  __DECLARE_VAR(LREAL,VAL)
  __DECLARE_VAR(BYTE,OK)

  // FB private variables - TEMP, private and located variables

} EEWRITELREAL;

void EEWRITELREAL_init__(EEWRITELREAL *data__, BOOL retain);
// Code part
void EEWRITELREAL_body__(EEWRITELREAL *data__);
// FUNCTION_BLOCK EEWRITEWORD
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(EEREGWORD,REG)
  __DECLARE_VAR(WORD,VAL)
  __DECLARE_VAR(BYTE,OK)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(EEREGLREAL,REGLREAL)
  EEWRITELREAL FUNC;

} EEWRITEWORD;

void EEWRITEWORD_init__(EEWRITEWORD *data__, BOOL retain);
// Code part
void EEWRITEWORD_body__(EEWRITEWORD *data__);
// FUNCTION_BLOCK EEREADBYTE
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(EEREGBYTE,REG)
  __DECLARE_VAR(BYTE,OVAL)
  __DECLARE_VAR(BYTE,OK)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(EEREGLREAL,REGLREAL)
  EEREADLREAL FUNC;

} EEREADBYTE;

void EEREADBYTE_init__(EEREADBYTE *data__, BOOL retain);
// Code part
void EEREADBYTE_body__(EEREADBYTE *data__);
// FUNCTION_BLOCK EEWRITELWORD
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(EEREGLWORD,REG)
  __DECLARE_VAR(LWORD,VAL)
  __DECLARE_VAR(BYTE,OK)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(EEREGLREAL,REGLREAL)
  EEWRITELREAL FUNC;

} EEWRITELWORD;

void EEWRITELWORD_init__(EEWRITELWORD *data__, BOOL retain);
// Code part
void EEWRITELWORD_body__(EEWRITELWORD *data__);
// FUNCTION_BLOCK EEWRITEREAL
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(EEREGREAL,REG)
  __DECLARE_VAR(REAL,VAL)
  __DECLARE_VAR(BYTE,OK)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(EEREGLREAL,REGLREAL)
  EEWRITELREAL FUNC;

} EEWRITEREAL;

void EEWRITEREAL_init__(EEWRITEREAL *data__, BOOL retain);
// Code part
void EEWRITEREAL_body__(EEWRITEREAL *data__);
// FUNCTION_BLOCK EEREADREAL
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(EEREGREAL,REG)
  __DECLARE_VAR(REAL,OVAL)
  __DECLARE_VAR(BYTE,OK)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(EEREGLREAL,REGLREAL)
  EEREADLREAL FUNC;

} EEREADREAL;

void EEREADREAL_init__(EEREADREAL *data__, BOOL retain);
// Code part
void EEREADREAL_body__(EEREADREAL *data__);
// FUNCTION_BLOCK EEWRITEBYTE
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(EEREGBYTE,REG)
  __DECLARE_VAR(BYTE,VAL)
  __DECLARE_VAR(BYTE,OK)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(EEREGLREAL,REGLREAL)
  EEWRITELREAL FUNC;

} EEWRITEBYTE;

void EEWRITEBYTE_init__(EEWRITEBYTE *data__, BOOL retain);
// Code part
void EEWRITEBYTE_body__(EEWRITEBYTE *data__);
// FUNCTION_BLOCK EEREADWORD
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(EEREGWORD,REG)
  __DECLARE_VAR(WORD,OVAL)
  __DECLARE_VAR(BYTE,OK)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(EEREGLREAL,REGLREAL)
  EEREADLREAL FUNC;

} EEREADWORD;

void EEREADWORD_init__(EEREADWORD *data__, BOOL retain);
// Code part
void EEREADWORD_body__(EEREADWORD *data__);
// FUNCTION_BLOCK EEREADDWORD
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(EEREGDWORD,REG)
  __DECLARE_VAR(DWORD,OVAL)
  __DECLARE_VAR(BYTE,OK)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(EEREGLREAL,REGLREAL)
  EEREADLREAL FUNC;

} EEREADDWORD;

void EEREADDWORD_init__(EEREADDWORD *data__, BOOL retain);
// Code part
void EEREADDWORD_body__(EEREADDWORD *data__);
// FUNCTION_BLOCK EEWRITEDWORD
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(EEREGDWORD,REG)
  __DECLARE_VAR(DWORD,VAL)
  __DECLARE_VAR(BYTE,OK)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(EEREGLREAL,REGLREAL)
  EEWRITELREAL FUNC;

} EEWRITEDWORD;

void EEWRITEDWORD_init__(EEWRITEDWORD *data__, BOOL retain);
// Code part
void EEWRITEDWORD_body__(EEWRITEDWORD *data__);
// FUNCTION_BLOCK MBRTUWRITEDWORD
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(BYTE,COM)
  __DECLARE_VAR(BYTE,ID)
  __DECLARE_VAR(BYTE,FUNC)
  __DECLARE_VAR(WORD,ADDR1)
  __DECLARE_VAR(BYTE,NUM)
  __DECLARE_VAR(BYTE,BO)
  __DECLARE_VAR(DWORD,I1)
  __DECLARE_VAR(DWORD,I2)
  __DECLARE_VAR(DWORD,I3)
  __DECLARE_VAR(DWORD,I4)
  __DECLARE_VAR(DWORD,I5)
  __DECLARE_VAR(DWORD,I6)
  __DECLARE_VAR(DWORD,I7)
  __DECLARE_VAR(DWORD,I8)
  __DECLARE_VAR(BYTE,OK)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(BOOL,EXPREV)

} MBRTUWRITEDWORD;

void MBRTUWRITEDWORD_init__(MBRTUWRITEDWORD *data__, BOOL retain);
// Code part
void MBRTUWRITEDWORD_body__(MBRTUWRITEDWORD *data__);
// FUNCTION_BLOCK MBRTUWRITEREAL
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(BYTE,COM)
  __DECLARE_VAR(BYTE,ID)
  __DECLARE_VAR(BYTE,FUNC)
  __DECLARE_VAR(WORD,ADDR1)
  __DECLARE_VAR(BYTE,NUM)
  __DECLARE_VAR(BYTE,BO)
  __DECLARE_VAR(REAL,I1)
  __DECLARE_VAR(REAL,I2)
  __DECLARE_VAR(REAL,I3)
  __DECLARE_VAR(REAL,I4)
  __DECLARE_VAR(REAL,I5)
  __DECLARE_VAR(REAL,I6)
  __DECLARE_VAR(REAL,I7)
  __DECLARE_VAR(REAL,I8)
  __DECLARE_VAR(BYTE,OK)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(BOOL,EXPREV)

} MBRTUWRITEREAL;

void MBRTUWRITEREAL_init__(MBRTUWRITEREAL *data__, BOOL retain);
// Code part
void MBRTUWRITEREAL_body__(MBRTUWRITEREAL *data__);
// FUNCTION_BLOCK MBRTUWRITEDINT
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(BYTE,COM)
  __DECLARE_VAR(BYTE,ID)
  __DECLARE_VAR(BYTE,FUNC)
  __DECLARE_VAR(WORD,ADDR1)
  __DECLARE_VAR(BYTE,NUM)
  __DECLARE_VAR(BYTE,BO)
  __DECLARE_VAR(DINT,I1)
  __DECLARE_VAR(DINT,I2)
  __DECLARE_VAR(DINT,I3)
  __DECLARE_VAR(DINT,I4)
  __DECLARE_VAR(DINT,I5)
  __DECLARE_VAR(DINT,I6)
  __DECLARE_VAR(DINT,I7)
  __DECLARE_VAR(DINT,I8)
  __DECLARE_VAR(BYTE,OK)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(BOOL,EXPREV)

} MBRTUWRITEDINT;

void MBRTUWRITEDINT_init__(MBRTUWRITEDINT *data__, BOOL retain);
// Code part
void MBRTUWRITEDINT_body__(MBRTUWRITEDINT *data__);
// FUNCTION_BLOCK MBRTUREADBOOL
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(BYTE,COM)
  __DECLARE_VAR(BYTE,ID)
  __DECLARE_VAR(BYTE,FUNC)
  __DECLARE_VAR(WORD,ADDR1)
  __DECLARE_VAR(BYTE,NUM)
  __DECLARE_VAR(BYTE,OK)
  __DECLARE_VAR(BOOL,O1)
  __DECLARE_VAR(BOOL,O2)
  __DECLARE_VAR(BOOL,O3)
  __DECLARE_VAR(BOOL,O4)
  __DECLARE_VAR(BOOL,O5)
  __DECLARE_VAR(BOOL,O6)
  __DECLARE_VAR(BOOL,O7)
  __DECLARE_VAR(BOOL,O8)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(BOOL,EXPREV)

} MBRTUREADBOOL;

void MBRTUREADBOOL_init__(MBRTUREADBOOL *data__, BOOL retain);
// Code part
void MBRTUREADBOOL_body__(MBRTUREADBOOL *data__);
// FUNCTION_BLOCK MBRTUREADDWORD
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(BYTE,COM)
  __DECLARE_VAR(BYTE,ID)
  __DECLARE_VAR(BYTE,FUNC)
  __DECLARE_VAR(WORD,ADDR1)
  __DECLARE_VAR(BYTE,NUM)
  __DECLARE_VAR(BYTE,BO)
  __DECLARE_VAR(BYTE,OK)
  __DECLARE_VAR(DWORD,O1)
  __DECLARE_VAR(DWORD,O2)
  __DECLARE_VAR(DWORD,O3)
  __DECLARE_VAR(DWORD,O4)
  __DECLARE_VAR(DWORD,O5)
  __DECLARE_VAR(DWORD,O6)
  __DECLARE_VAR(DWORD,O7)
  __DECLARE_VAR(DWORD,O8)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(BOOL,EXPREV)

} MBRTUREADDWORD;

void MBRTUREADDWORD_init__(MBRTUREADDWORD *data__, BOOL retain);
// Code part
void MBRTUREADDWORD_body__(MBRTUREADDWORD *data__);
// FUNCTION_BLOCK MBRTUREADINT
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(BYTE,COM)
  __DECLARE_VAR(BYTE,ID)
  __DECLARE_VAR(BYTE,FUNC)
  __DECLARE_VAR(WORD,ADDR1)
  __DECLARE_VAR(BYTE,NUM)
  __DECLARE_VAR(BYTE,BO)
  __DECLARE_VAR(BYTE,OK)
  __DECLARE_VAR(INT,O1)
  __DECLARE_VAR(INT,O2)
  __DECLARE_VAR(INT,O3)
  __DECLARE_VAR(INT,O4)
  __DECLARE_VAR(INT,O5)
  __DECLARE_VAR(INT,O6)
  __DECLARE_VAR(INT,O7)
  __DECLARE_VAR(INT,O8)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(BOOL,EXPREV)

} MBRTUREADINT;

void MBRTUREADINT_init__(MBRTUREADINT *data__, BOOL retain);
// Code part
void MBRTUREADINT_body__(MBRTUREADINT *data__);
// FUNCTION_BLOCK MBRTUREADREAL
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(BYTE,COM)
  __DECLARE_VAR(BYTE,ID)
  __DECLARE_VAR(BYTE,FUNC)
  __DECLARE_VAR(WORD,ADDR1)
  __DECLARE_VAR(BYTE,NUM)
  __DECLARE_VAR(BYTE,BO)
  __DECLARE_VAR(BYTE,OK)
  __DECLARE_VAR(REAL,O1)
  __DECLARE_VAR(REAL,O2)
  __DECLARE_VAR(REAL,O3)
  __DECLARE_VAR(REAL,O4)
  __DECLARE_VAR(REAL,O5)
  __DECLARE_VAR(REAL,O6)
  __DECLARE_VAR(REAL,O7)
  __DECLARE_VAR(REAL,O8)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(BOOL,EXPREV)

} MBRTUREADREAL;

void MBRTUREADREAL_init__(MBRTUREADREAL *data__, BOOL retain);
// Code part
void MBRTUREADREAL_body__(MBRTUREADREAL *data__);
// FUNCTION_BLOCK MBRTUREADDINT
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(BYTE,COM)
  __DECLARE_VAR(BYTE,ID)
  __DECLARE_VAR(BYTE,FUNC)
  __DECLARE_VAR(WORD,ADDR1)
  __DECLARE_VAR(BYTE,NUM)
  __DECLARE_VAR(BYTE,BO)
  __DECLARE_VAR(BYTE,OK)
  __DECLARE_VAR(DINT,O1)
  __DECLARE_VAR(DINT,O2)
  __DECLARE_VAR(DINT,O3)
  __DECLARE_VAR(DINT,O4)
  __DECLARE_VAR(DINT,O5)
  __DECLARE_VAR(DINT,O6)
  __DECLARE_VAR(DINT,O7)
  __DECLARE_VAR(DINT,O8)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(BOOL,EXPREV)

} MBRTUREADDINT;

void MBRTUREADDINT_init__(MBRTUREADDINT *data__, BOOL retain);
// Code part
void MBRTUREADDINT_body__(MBRTUREADDINT *data__);
// FUNCTION_BLOCK MBRTUWRITEBOOL
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(BYTE,COM)
  __DECLARE_VAR(BYTE,ID)
  __DECLARE_VAR(BYTE,FUNC)
  __DECLARE_VAR(WORD,ADDR1)
  __DECLARE_VAR(BYTE,NUM)
  __DECLARE_VAR(BOOL,I1)
  __DECLARE_VAR(BOOL,I2)
  __DECLARE_VAR(BOOL,I3)
  __DECLARE_VAR(BOOL,I4)
  __DECLARE_VAR(BOOL,I5)
  __DECLARE_VAR(BOOL,I6)
  __DECLARE_VAR(BOOL,I7)
  __DECLARE_VAR(BOOL,I8)
  __DECLARE_VAR(BYTE,OK)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(BOOL,EXPREV)

} MBRTUWRITEBOOL;

void MBRTUWRITEBOOL_init__(MBRTUWRITEBOOL *data__, BOOL retain);
// Code part
void MBRTUWRITEBOOL_body__(MBRTUWRITEBOOL *data__);
// FUNCTION_BLOCK MBRTUREADWORD
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(BYTE,COM)
  __DECLARE_VAR(BYTE,ID)
  __DECLARE_VAR(BYTE,FUNC)
  __DECLARE_VAR(WORD,ADDR1)
  __DECLARE_VAR(BYTE,NUM)
  __DECLARE_VAR(BYTE,BO)
  __DECLARE_VAR(BYTE,OK)
  __DECLARE_VAR(WORD,O1)
  __DECLARE_VAR(WORD,O2)
  __DECLARE_VAR(WORD,O3)
  __DECLARE_VAR(WORD,O4)
  __DECLARE_VAR(WORD,O5)
  __DECLARE_VAR(WORD,O6)
  __DECLARE_VAR(WORD,O7)
  __DECLARE_VAR(WORD,O8)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(BOOL,EXPREV)

} MBRTUREADWORD;

void MBRTUREADWORD_init__(MBRTUREADWORD *data__, BOOL retain);
// Code part
void MBRTUREADWORD_body__(MBRTUREADWORD *data__);
// FUNCTION_BLOCK MBRTUWRITEINT
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(BYTE,COM)
  __DECLARE_VAR(BYTE,ID)
  __DECLARE_VAR(BYTE,FUNC)
  __DECLARE_VAR(WORD,ADDR1)
  __DECLARE_VAR(BYTE,NUM)
  __DECLARE_VAR(BYTE,BO)
  __DECLARE_VAR(INT,I1)
  __DECLARE_VAR(INT,I2)
  __DECLARE_VAR(INT,I3)
  __DECLARE_VAR(INT,I4)
  __DECLARE_VAR(INT,I5)
  __DECLARE_VAR(INT,I6)
  __DECLARE_VAR(INT,I7)
  __DECLARE_VAR(INT,I8)
  __DECLARE_VAR(BYTE,OK)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(BOOL,EXPREV)

} MBRTUWRITEINT;

void MBRTUWRITEINT_init__(MBRTUWRITEINT *data__, BOOL retain);
// Code part
void MBRTUWRITEINT_body__(MBRTUWRITEINT *data__);
// FUNCTION_BLOCK MBRTUWRITEWORD
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(BYTE,COM)
  __DECLARE_VAR(BYTE,ID)
  __DECLARE_VAR(BYTE,FUNC)
  __DECLARE_VAR(WORD,ADDR1)
  __DECLARE_VAR(BYTE,NUM)
  __DECLARE_VAR(BYTE,BO)
  __DECLARE_VAR(WORD,I1)
  __DECLARE_VAR(WORD,I2)
  __DECLARE_VAR(WORD,I3)
  __DECLARE_VAR(WORD,I4)
  __DECLARE_VAR(WORD,I5)
  __DECLARE_VAR(WORD,I6)
  __DECLARE_VAR(WORD,I7)
  __DECLARE_VAR(WORD,I8)
  __DECLARE_VAR(BYTE,OK)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(BOOL,EXPREV)

} MBRTUWRITEWORD;

void MBRTUWRITEWORD_init__(MBRTUWRITEWORD *data__, BOOL retain);
// Code part
void MBRTUWRITEWORD_body__(MBRTUWRITEWORD *data__);
// FUNCTION_BLOCK DICNTT
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(BYTE,DIN)
  __DECLARE_VAR(WORD,REF)
  __DECLARE_VAR(BOOL,REFEN)
  __DECLARE_VAR(WORD,OV)
  __DECLARE_VAR(BOOL,OREF)
  __DECLARE_VAR(BYTE,OK)

  // FB private variables - TEMP, private and located variables

} DICNTT;

void DICNTT_init__(DICNTT *data__, BOOL retain);
// Code part
void DICNTT_body__(DICNTT *data__);
// FUNCTION_BLOCK DICNT
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(BYTE,DIN)
  __DECLARE_VAR(DWORD,REF)
  __DECLARE_VAR(BOOL,REFEN)
  __DECLARE_VAR(DWORD,OV)
  __DECLARE_VAR(BOOL,OREF)
  __DECLARE_VAR(BYTE,OK)

  // FB private variables - TEMP, private and located variables

} DICNT;

void DICNT_init__(DICNT *data__, BOOL retain);
// Code part
void DICNT_body__(DICNT *data__);
// FUNCTION_BLOCK DIENC
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(BYTE,DIN)
  __DECLARE_VAR(DWORD,REFA)
  __DECLARE_VAR(BOOL,REFAEN)
  __DECLARE_VAR(DWORD,REFB)
  __DECLARE_VAR(BOOL,REFBEN)
  __DECLARE_VAR(WORD,REFT)
  __DECLARE_VAR(BOOL,REFTEN)
  __DECLARE_VAR(DWORD,OA)
  __DECLARE_VAR(BOOL,OAREF)
  __DECLARE_VAR(DWORD,OB)
  __DECLARE_VAR(BOOL,OBREF)
  __DECLARE_VAR(WORD,OT)
  __DECLARE_VAR(BOOL,OTREF)
  __DECLARE_VAR(BYTE,OK)

  // FB private variables - TEMP, private and located variables

} DIENC;

void DIENC_init__(DIENC *data__, BOOL retain);
// Code part
void DIENC_body__(DIENC *data__);
// FUNCTION_BLOCK DIVAL
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(BYTE,DIN)
  __DECLARE_VAR(BOOL,OV)
  __DECLARE_VAR(BYTE,OK)

  // FB private variables - TEMP, private and located variables

} DIVAL;

void DIVAL_init__(DIVAL *data__, BOOL retain);
// Code part
void DIVAL_body__(DIVAL *data__);
// FUNCTION_BLOCK DICNTRST
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(BYTE,DIN)
  __DECLARE_VAR(BOOL,RST)
  __DECLARE_VAR(BYTE,OK)

  // FB private variables - TEMP, private and located variables

} DICNTRST;

void DICNTRST_init__(DICNTRST *data__, BOOL retain);
// Code part
void DICNTRST_body__(DICNTRST *data__);
// FUNCTION_BLOCK DIMODE
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(BYTE,DIN)
  __DECLARE_VAR(BYTE,M)
  __DECLARE_VAR(BYTE,OM)
  __DECLARE_VAR(BYTE,OK)

  // FB private variables - TEMP, private and located variables

} DIMODE;

void DIMODE_init__(DIMODE *data__, BOOL retain);
// Code part
void DIMODE_body__(DIMODE *data__);
// FUNCTION_BLOCK AIMODE
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(BYTE,AIN)
  __DECLARE_VAR(BYTE,M)
  __DECLARE_VAR(BYTE,OM)
  __DECLARE_VAR(BYTE,OS)
  __DECLARE_VAR(BYTE,OK)

  // FB private variables - TEMP, private and located variables

} AIMODE;

void AIMODE_init__(AIMODE *data__, BOOL retain);
// Code part
void AIMODE_body__(AIMODE *data__);
// FUNCTION_BLOCK AIVAL
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(BYTE,AIN)
  __DECLARE_VAR(REAL,OV)
  __DECLARE_VAR(BYTE,OS)
  __DECLARE_VAR(BYTE,OK)

  // FB private variables - TEMP, private and located variables

} AIVAL;

void AIVAL_init__(AIVAL *data__, BOOL retain);
// Code part
void AIVAL_body__(AIVAL *data__);
// FUNCTION_BLOCK DTSETID
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(BYTE,DTN)
  __DECLARE_VAR(LWORD,ID)
  __DECLARE_VAR(LWORD,OID)
  __DECLARE_VAR(BYTE,OK)

  // FB private variables - TEMP, private and located variables

} DTSETID;

void DTSETID_init__(DTSETID *data__, BOOL retain);
// Code part
void DTSETID_body__(DTSETID *data__);
// FUNCTION_BLOCK DTVAL
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(BYTE,DTN)
  __DECLARE_VAR(REAL,OV)
  __DECLARE_VAR(BYTE,OS)
  __DECLARE_VAR(BYTE,OK)

  // FB private variables - TEMP, private and located variables

} DTVAL;

void DTVAL_init__(DTVAL *data__, BOOL retain);
// Code part
void DTVAL_body__(DTVAL *data__);
// FUNCTION_BLOCK DTGETID
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(BYTE,DTN)
  __DECLARE_VAR(LWORD,OID)
  __DECLARE_VAR(BYTE,OK)

  // FB private variables - TEMP, private and located variables

} DTGETID;

void DTGETID_init__(DTGETID *data__, BOOL retain);
// Code part
void DTGETID_body__(DTGETID *data__);
// FUNCTION_BLOCK DTMODE
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(BYTE,DTN)
  __DECLARE_VAR(BYTE,M)
  __DECLARE_VAR(BYTE,OM)
  __DECLARE_VAR(BYTE,OS)
  __DECLARE_VAR(BYTE,OK)

  // FB private variables - TEMP, private and located variables

} DTMODE;

void DTMODE_init__(DTMODE *data__, BOOL retain);
// Code part
void DTMODE_body__(DTMODE *data__);
// FUNCTION_BLOCK PTMODE
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(BYTE,PTN)
  __DECLARE_VAR(BYTE,M)
  __DECLARE_VAR(BYTE,STY)
  __DECLARE_VAR(BYTE,OM)
  __DECLARE_VAR(BYTE,OS)
  __DECLARE_VAR(BYTE,OK)

  // FB private variables - TEMP, private and located variables

} PTMODE;

void PTMODE_init__(PTMODE *data__, BOOL retain);
// Code part
void PTMODE_body__(PTMODE *data__);
// FUNCTION_BLOCK PTVAL
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(BYTE,PTN)
  __DECLARE_VAR(REAL,OV)
  __DECLARE_VAR(BYTE,OS)
  __DECLARE_VAR(BYTE,OK)

  // FB private variables - TEMP, private and located variables

} PTVAL;

void PTVAL_init__(PTVAL *data__, BOOL retain);
// Code part
void PTVAL_body__(PTVAL *data__);
// FUNCTION_BLOCK DOPWM
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(BOOL,ENX)
  __DECLARE_VAR(BYTE,DON)
  __DECLARE_VAR(DWORD,TM)
  __DECLARE_VAR(REAL,DU)
  __DECLARE_VAR(BOOL,OW)
  __DECLARE_VAR(BYTE,OK)

  // FB private variables - TEMP, private and located variables

} DOPWM;

void DOPWM_init__(DOPWM *data__, BOOL retain);
// Code part
void DOPWM_body__(DOPWM *data__);
// FUNCTION_BLOCK DOSAFE
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(BOOL,ENX)
  __DECLARE_VAR(BYTE,DON)
  __DECLARE_VAR(BOOL,V)
  __DECLARE_VAR(BOOL,OV)
  __DECLARE_VAR(BOOL,OW)
  __DECLARE_VAR(BYTE,OK)

  // FB private variables - TEMP, private and located variables

} DOSAFE;

void DOSAFE_init__(DOSAFE *data__, BOOL retain);
// Code part
void DOSAFE_body__(DOSAFE *data__);
// FUNCTION_BLOCK DOMODE
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(BYTE,DON)
  __DECLARE_VAR(BYTE,M)
  __DECLARE_VAR(BYTE,OM)
  __DECLARE_VAR(BYTE,OK)

  // FB private variables - TEMP, private and located variables

} DOMODE;

void DOMODE_init__(DOMODE *data__, BOOL retain);
// Code part
void DOMODE_body__(DOMODE *data__);
// FUNCTION_BLOCK DOVAL
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(BYTE,DON)
  __DECLARE_VAR(BOOL,V)
  __DECLARE_VAR(BOOL,OV)
  __DECLARE_VAR(BYTE,OK)

  // FB private variables - TEMP, private and located variables

} DOVAL;

void DOVAL_init__(DOVAL *data__, BOOL retain);
// Code part
void DOVAL_body__(DOVAL *data__);
// FUNCTION_BLOCK DOFAST
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(BYTE,DON)
  __DECLARE_VAR(BOOL,V)
  __DECLARE_VAR(BOOL,OV)
  __DECLARE_VAR(BYTE,OK)

  // FB private variables - TEMP, private and located variables

} DOFAST;

void DOFAST_init__(DOFAST *data__, BOOL retain);
// Code part
void DOFAST_body__(DOFAST *data__);
// FUNCTION_BLOCK AOFAST
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(BYTE,AON)
  __DECLARE_VAR(REAL,V)
  __DECLARE_VAR(REAL,OV)
  __DECLARE_VAR(BYTE,OK)

  // FB private variables - TEMP, private and located variables

} AOFAST;

void AOFAST_init__(AOFAST *data__, BOOL retain);
// Code part
void AOFAST_body__(AOFAST *data__);
// FUNCTION_BLOCK AOMODE
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(BYTE,AON)
  __DECLARE_VAR(BYTE,M)
  __DECLARE_VAR(BYTE,OM)
  __DECLARE_VAR(BYTE,OK)

  // FB private variables - TEMP, private and located variables

} AOMODE;

void AOMODE_init__(AOMODE *data__, BOOL retain);
// Code part
void AOMODE_body__(AOMODE *data__);
// FUNCTION_BLOCK AOVAL
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(BYTE,AON)
  __DECLARE_VAR(REAL,V)
  __DECLARE_VAR(REAL,OV)
  __DECLARE_VAR(BYTE,OK)

  // FB private variables - TEMP, private and located variables

} AOVAL;

void AOVAL_init__(AOVAL *data__, BOOL retain);
// Code part
void AOVAL_body__(AOVAL *data__);
// FUNCTION_BLOCK AOSAFE
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,EX)
  __DECLARE_VAR(BOOL,ENX)
  __DECLARE_VAR(BYTE,AON)
  __DECLARE_VAR(REAL,V)
  __DECLARE_VAR(REAL,OV)
  __DECLARE_VAR(BOOL,OW)
  __DECLARE_VAR(BYTE,OK)

  // FB private variables - TEMP, private and located variables

} AOSAFE;

void AOSAFE_init__(AOSAFE *data__, BOOL retain);
// Code part
void AOSAFE_body__(AOSAFE *data__);
// PROGRAM PROGRAM0
// Data part
typedef struct {
  // PROGRAM Interface - IN, OUT, IN_OUT variables

  // PROGRAM private variables - TEMP, private and located variables
  __DECLARE_VAR(BYTE,CH0)
  __DECLARE_VAR(BYTE,CH0_MODE)
  __DECLARE_VAR(BYTE,CH0_MODERES)
  __DECLARE_VAR(BYTE,CH0_MODEOK)
  __DECLARE_VAR(DWORD,CH0_CNTREF)
  __DECLARE_VAR(DWORD,CH0_CNT)
  __DECLARE_VAR(BYTE,CH0_CNTOK)
  DIMODE DIMODE0;
  DICNT DICNT0;
  __DECLARE_VAR(BOOL,SOFTRESET19_OUT)

} PROGRAM0;

void PROGRAM0_init__(PROGRAM0 *data__, BOOL retain);
// Code part
void PROGRAM0_body__(PROGRAM0 *data__);
#endif //__POUS_H
